@rem FASMLIB
@rem makefile to build FASMLIB in .LIB format
@rem for use with FASM/NASM/YASM (no name decorations)

set OS=win32
set OUT=..\fasmlib2.lib

del /Q objlist.txt
rd /S /Q obj

mkdir obj
cd obj
mkdir fasmlib
mkdir err
mkdir mem
mkdir str
mkdir fileio
mkdir process
mkdir stream
mkdir fstream
mkdir mstream
mkdir conv
mkdir text
mkdir stdstream
mkdir stdout
mkdir stderr
mkdir stdin
cd ..

set DESTDIR=fasmlib
set SRCDIR=%FASMLIB%\src\fasmlib
call file.bat init
call file.bat uninit
call file.bat shutdown

set DESTDIR=err
set SRCDIR=%FASMLIB%\src\err
call file.bat text


set DESTDIR=mem
set SRCDIR=%FASMLIB%\src\mem
call file.bat alloc0
call file.bat cmp
call file.bat copy
call file.bat fill
call file.bat find
call file.bat findb
call file.bat realloc0
set SRCDIR=%FASMLIB%\src\_%OS%\mem
call file.bat init
call file.bat uninit
call file.bat alloc
call file.bat free
call file.bat realloc
call file.bat size


set DESTDIR=str
set SRCDIR=%FASMLIB%\src\str
call file.bat cat
call file.bat catchar
call file.bat cmp
call file.bat cmpi
call file.bat copy
call file.bat ins
call file.bat inschar
call file.bat len
call file.bat lowcase
call file.bat upcase
call file.bat pos
call file.bat poschar
call file.bat sub


set DESTDIR=fileio
set SRCDIR=%FASMLIB%\src\fileio
call file.bat append
call file.bat size
set SRCDIR=%FASMLIB%\src\_%OS%\fileio
call file.bat open
call file.bat create
call file.bat close
call file.bat read
call file.bat write
call file.bat seek
call file.bat tell


set DESTDIR=process
set SRCDIR=%FASMLIB%\src\_%OS%\process
call file.bat exit


set DESTDIR=stream
set SRCDIR=%FASMLIB%\src\stream
call file.bat close
call file.bat create
call file.bat seek
call file.bat peek
call file.bat peek_byte
call file.bat read
call file.bat read_byte
call file.bat skip
call file.bat tell
call file.bat write
call file.bat write_byte
call file.bat write_word
call file.bat write_dword
call file.bat _def_read
call file.bat _def_peek

set DESTDIR=stdstream
set SRCDIR=%FASMLIB%\src\_%OS%\stdstream
call file.bat init
call file.bat uninit
call file.bat stdout
call file.bat stdin
call file.bat stderr


set DESTDIR=conv
set SRCDIR=%FASMLIB%\src\conv
call file.bat _dec2d
call file.bat _dec2id
call file.bat _hex2d
call file.bat _hex2id
call file.bat _hextable
call file.bat b_hex
call file.bat w_hex
call file.bat d_hex
call file.bat q_hex
call file.bat b_dec
call file.bat w_dec
call file.bat d_dec
call file.bat q_dec
call file.bat ib_hex
call file.bat iw_hex
call file.bat id_hex
call file.bat iq_hex
call file.bat ib_dec
call file.bat iw_dec
call file.bat id_dec
call file.bat iq_dec
call file.bat hex_b
call file.bat hex_w
call file.bat hex_d
call file.bat hex_q
call file.bat hex_ib
call file.bat hex_iw
call file.bat hex_id
call file.bat hex_iq
call file.bat dec_b
call file.bat dec_w
call file.bat dec_d
call file.bat dec_q
call file.bat dec_ib
call file.bat dec_iw
call file.bat dec_id
call file.bat dec_iq
call file.bat ext_b_hex
call file.bat ext_w_hex
call file.bat ext_d_hex
call file.bat ext_q_hex
call file.bat ext_b_dec
call file.bat ext_w_dec
call file.bat ext_d_dec
call file.bat ext_q_dec
call file.bat ext_ib_hex
call file.bat ext_iw_hex
call file.bat ext_id_hex
call file.bat ext_iq_hex
call file.bat ext_ib_dec
call file.bat ext_iw_dec
call file.bat ext_id_dec
call file.bat ext_iq_dec
call file.bat ext_hex_b
call file.bat ext_hex_w
call file.bat ext_hex_d
call file.bat ext_hex_q
call file.bat ext_hex_ib
call file.bat ext_hex_iw
call file.bat ext_hex_id
call file.bat ext_hex_iq
call file.bat ext_dec_b
call file.bat ext_dec_w
call file.bat ext_dec_d
call file.bat ext_dec_q
call file.bat ext_dec_ib
call file.bat ext_dec_iw
call file.bat ext_dec_id
call file.bat ext_dec_iq


set DESTDIR=text
set SRCDIR=%FASMLIB%\src\text
call file.bat _bleol_chars
call file.bat _read_dec2d
call file.bat _read_dec2id
call file.bat _read_hex2d
call file.bat _read_hex2id
call file.bat write
call file.bat write_char
call file.bat write_str
call file.bat write_format
call file.bat write_hex
call file.bat write_b_hex
call file.bat write_w_hex
call file.bat write_d_hex
call file.bat write_q_hex
call file.bat write_dec
call file.bat write_b_dec
call file.bat write_w_dec
call file.bat write_d_dec
call file.bat write_q_dec
call file.bat write_ihex
call file.bat write_ib_hex
call file.bat write_iw_hex
call file.bat write_id_hex
call file.bat write_iq_hex
call file.bat write_idec
call file.bat write_ib_dec
call file.bat write_iw_dec
call file.bat write_id_dec
call file.bat write_iq_dec
call file.bat ext_write_hex
call file.bat ext_write_b_hex
call file.bat ext_write_w_hex
call file.bat ext_write_d_hex
call file.bat ext_write_q_hex
call file.bat ext_write_dec
call file.bat ext_write_b_dec
call file.bat ext_write_w_dec
call file.bat ext_write_d_dec
call file.bat ext_write_q_dec
call file.bat ext_write_ihex
call file.bat ext_write_ib_hex
call file.bat ext_write_iw_hex
call file.bat ext_write_id_hex
call file.bat ext_write_iq_hex
call file.bat ext_write_idec
call file.bat ext_write_ib_dec
call file.bat ext_write_iw_dec
call file.bat ext_write_iq_dec
call file.bat ext_write_id_dec
call file.bat read_char
call file.bat read_chars
call file.bat read_until
call file.bat read_line
call file.bat read_hex
call file.bat read_hex_b
call file.bat read_hex_w
call file.bat read_hex_d
call file.bat read_hex_q
call file.bat read_ihex
call file.bat read_hex_ib
call file.bat read_hex_iw
call file.bat read_hex_id
call file.bat read_hex_iq
call file.bat read_dec
call file.bat read_dec_b
call file.bat read_dec_w
call file.bat read_dec_d
call file.bat read_dec_q
call file.bat read_idec
call file.bat read_dec_ib
call file.bat read_dec_iw
call file.bat read_dec_id
call file.bat read_dec_iq
call file.bat fetch
call file.bat fetch_str
call file.bat fetch_char
call file.bat skip_chars
call file.bat skip_until
call file.bat ext_read_chars
call file.bat ext_read_until
call file.bat ext_read_line
call file.bat ext_read_hex
call file.bat ext_read_hex_b
call file.bat ext_read_hex_w
call file.bat ext_read_hex_d
call file.bat ext_read_hex_q
call file.bat ext_read_ihex
call file.bat ext_read_hex_ib
call file.bat ext_read_hex_iw
call file.bat ext_read_hex_id
call file.bat ext_read_hex_iq
call file.bat ext_read_dec
call file.bat ext_read_dec_b
call file.bat ext_read_dec_w
call file.bat ext_read_dec_d
call file.bat ext_read_dec_q
call file.bat ext_read_idec
call file.bat ext_read_dec_ib
call file.bat ext_read_dec_iw
call file.bat ext_read_dec_id
call file.bat ext_read_dec_iq
call file.bat ext_skip_chars
call file.bat ext_skip_until


set DESTDIR=stdout
set SRCDIR=%FASMLIB%\src\stdstream\stdout
call file.bat write
call file.bat write_char
call file.bat write_str
call file.bat write_format
call file.bat write_hex
call file.bat write_b_hex
call file.bat write_w_hex
call file.bat write_d_hex
call file.bat write_q_hex
call file.bat write_dec
call file.bat write_b_dec
call file.bat write_w_dec
call file.bat write_d_dec
call file.bat write_q_dec
call file.bat write_ihex
call file.bat write_ib_hex
call file.bat write_iw_hex
call file.bat write_id_hex
call file.bat write_iq_hex
call file.bat write_idec
call file.bat write_ib_dec
call file.bat write_iw_dec
call file.bat write_id_dec
call file.bat write_iq_dec
call file.bat extwrite_hex
call file.bat extwrite_b_hex
call file.bat extwrite_w_hex
call file.bat extwrite_d_hex
call file.bat extwrite_q_hex
call file.bat extwrite_dec
call file.bat extwrite_b_dec
call file.bat extwrite_w_dec
call file.bat extwrite_d_dec
call file.bat extwrite_q_dec
call file.bat extwrite_ihex
call file.bat extwrite_ib_hex
call file.bat extwrite_iw_hex
call file.bat extwrite_id_hex
call file.bat extwrite_iq_hex
call file.bat extwrite_idec
call file.bat extwrite_ib_dec
call file.bat extwrite_iw_dec
call file.bat extwrite_id_dec
call file.bat extwrite_iq_dec

set DESTDIR=stderr
set SRCDIR=%FASMLIB%\src\stdstream\stderr
call file.bat write
call file.bat write_char
call file.bat write_str
call file.bat write_format
call file.bat write_hex
call file.bat write_b_hex
call file.bat write_w_hex
call file.bat write_d_hex
call file.bat write_q_hex
call file.bat write_dec
call file.bat write_b_dec
call file.bat write_w_dec
call file.bat write_d_dec
call file.bat write_q_dec
call file.bat write_ihex
call file.bat write_ib_hex
call file.bat write_iw_hex
call file.bat write_id_hex
call file.bat write_iq_hex
call file.bat write_idec
call file.bat write_ib_dec
call file.bat write_iw_dec
call file.bat write_id_dec
call file.bat write_iq_dec
call file.bat extwrite_hex
call file.bat extwrite_b_hex
call file.bat extwrite_w_hex
call file.bat extwrite_d_hex
call file.bat extwrite_q_hex
call file.bat extwrite_dec
call file.bat extwrite_b_dec
call file.bat extwrite_w_dec
call file.bat extwrite_d_dec
call file.bat extwrite_q_dec
call file.bat extwrite_ihex
call file.bat extwrite_ib_hex
call file.bat extwrite_iw_hex
call file.bat extwrite_id_hex
call file.bat extwrite_iq_hex
call file.bat extwrite_idec
call file.bat extwrite_ib_dec
call file.bat extwrite_iw_dec
call file.bat extwrite_id_dec
call file.bat extwrite_iq_dec

set DESTDIR=stdin
set SRCDIR=%FASMLIB%\src\stdstream\stdin
call file.bat read_char
call file.bat read_chars
call file.bat read_until
call file.bat read_line
call file.bat read_hex
call file.bat read_hex_b
call file.bat read_hex_w
call file.bat read_hex_d
call file.bat read_hex_q
call file.bat read_ihex
call file.bat read_hex_ib
call file.bat read_hex_iw
call file.bat read_hex_id
call file.bat read_hex_iq
call file.bat read_dec
call file.bat read_dec_b
call file.bat read_dec_w
call file.bat read_dec_d
call file.bat read_dec_q
call file.bat read_idec
call file.bat read_dec_ib
call file.bat read_dec_iw
call file.bat read_dec_id
call file.bat read_dec_iq
call file.bat fetch
call file.bat fetch_str
call file.bat fetch_char
call file.bat skip_chars
call file.bat skip_until
call file.bat extread_line
call file.bat extread_chars
call file.bat extread_until
call file.bat extread_hex
call file.bat extread_hex_b
call file.bat extread_hex_w
call file.bat extread_hex_d
call file.bat extread_hex_q
call file.bat extread_ihex
call file.bat extread_hex_ib
call file.bat extread_hex_iw
call file.bat extread_hex_id
call file.bat extread_hex_iq
call file.bat extread_dec
call file.bat extread_dec_b
call file.bat extread_dec_w
call file.bat extread_dec_d
call file.bat extread_dec_q
call file.bat extread_idec
call file.bat extread_dec_ib
call file.bat extread_dec_iw
call file.bat extread_dec_id
call file.bat extread_dec_iq
call file.bat extskip_chars
call file.bat extskip_until

set DESTDIR=fstream
set SRCDIR=%FASMLIB%\src\fstream
call file.bat _vtab
call file.bat _read
call file.bat _write
call file.bat _seek
call file.bat _close
call file.bat _tell
call file.bat _peek
call file.bat create
call file.bat extcreate
call file.bat open
call file.bat extopen
call file.bat append
call file.bat extappend
call file.bat open_handle
call file.bat extopen_handle
call file.bat read
call file.bat read_byte
call file.bat peek
call file.bat peek_byte
call file.bat write
call file.bat write_byte
call file.bat write_word
call file.bat write_dword
call file.bat seek
call file.bat tell
call file.bat close

set DESTDIR=mstream
set SRCDIR=%FASMLIB%\src\mstream
call file.bat _vtab
call file.bat _read
call file.bat _write
call file.bat _seek
call file.bat _skip
call file.bat _tell
call file.bat _peek
call file.bat create
call file.bat extcreate


cd obj
lib /nologo /out:..\%OUT% @..\objlist.txt
if errorlevel 1 goto error
cd ..

rd /S /Q obj
del /Q objlist.txt

goto finish


:error
pause


:finish
