; you can insert example codes from tutorials into
; this file, remove all "->", and try them by compiling
; win32.asm or linux.asm

	;size of our buffer
	TEXT_SIZE = 12


	idata {
	_prompt db 'Please enter text: ',0
	_text	db 'After str.ins and str.cat: ',0
	_text2	db '(a)',0
	_text3	db '(i)',0
	_error	db 'Error: ',0
	}

	udata {
	text	rb TEXT_SIZE
	}

	;initialize FASMLIB
	call	fasmlib.init
	jc	error

	;display prompt text
	push	_prompt
	call	stdout.write
	jc	error

	;read line from user
	push	TEXT_SIZE
	push	text
	call	stdin.read.line
	jc	error

	;ignore ERR_BUFFER_FULL
	jnc	insert_text3
	cmp	eax, ERR_BUFFER_FULL
	jne	error

	insert_text3:

	;insert text3
	push	5
	push	-1
	push	_text3
	push	TEXT_SIZE
	push	text
	call	str.ins

	;ignore ERR_OUT_OF_RANGE and ERR_BUFFER_FULL
	jnc	append_text2
	cmp	eax, ERR_OUT_OF_RANGE
	je	append_text2
	cmp	eax, ERR_BUFFER_FULL
	jne	error		;handle other errors as usual

	append_text2:

	;append text2
	push	-1
	push	_text2
	push	TEXT_SIZE
	push	text
	call	str.cat

	;ignore ERR_BUFFER_FULL
	jnc	display_text
	cmp	eax, ERR_BUFFER_FULL
	jne	error

	display_text:

	;display "Entered text:"
	push	_text
	call	stdout.write
	jc	error

	;display entered text
	push	TEXT_SIZE
	push	text
	call	stdout.write.str
	jc	error

	;uninitialize FASMLIB
	call	fasmlib.uninit
	jc	error

	;exit program
	push	0
	call	process.exit

	error:

	;EBX = text of error code in EAX
	push	eax
	call	err.text
	mov	ebx, eax

	;display "Error: "
	push	_error
	call	stderr.write

	;display error message
	push	ebx
	call	stderr.write

	;uninitialize modules
	call	fasmlib.uninit

	;exit with code 1
	push	1
	call	process.exit
