;portable part of code


;size of buffer
BUFSZ = 100

udata {
  ;buffer for text
  buf rb BUFSZ
}

start:
	;initialize FASMLIB
	call	fasmlib.init
	jc	error

	;create memory stream for our buffer
	libcall mstream.create, buf, BUFSZ
	jc	error
	mov	ebx, eax

	;write things to stream
	libcall text.write, ebx, <"blah blah",10>
	jc	error2
	libcall text.write.hex, ebx, 12347
	jc	error2
	libcall text.write.format, ebx, <10,"%id = %08h">, -253, -253
	jc	error2

	;to make string from text in buffer, we must end it with zero byte
	libcall stream.write.byte, ebx, 0
	jc	error2

	;close stream
	libcall stream.close, ebx
	jc	error

	;now we have string in our buffer, let's just print it
	libcall stdout.write, buf
	jc	error

	;uninitialize FASMLIB
	libcall fasmlib.uninit
	jc	error

	;end program with exit code 0
	libcall process.exit, 0



	;close EBX stream and print error
error2: push	eax
	libcall stream.close, ebx
	pop	eax

	;on error, EAX contains error code
error:
	;write error message
	libcall stderr.write.format, <10,"Error: %s!",10>, <libcall err.text, eax>

	;uninitialize FASMLIB
	libcall fasmlib.shutdown

	;end program with exit code 1
	libcall process.exit, 1