;portable part of code
;demonstrates libcall macro

BUFFER_SIZE = 80+1

udata {
  buffer  rb BUFFER_SIZE
}

start:
	;initialize FASMLIB
	call	fasmlib.init
	jc	error

	;write prompt
	libcall stdout.write.format, <"Please enter line of text (up to %d chars):",10>, BUFFER_SIZE-1
	jc	error

	;EBX = read one line of text
	libcall stdin.read.line, buffer, BUFFER_SIZE
	jc	error

	;convert text char-by-char
	mov	esi, buffer
@@:	lodsb
	test	al, al
	je	@f
	libcall stdout.write.format, "%02Bx ", eax
	jc	error
	jmp	@b
@@:

	;write EOL
	libcall stdout.write, <10,10>

	;uninitialize FASMLIB
	call	fasmlib.uninit
	jc	error

	;end program with exit code 0
	libcall process.exit, 0



	;on error, EAX contains error code
error:
	;EAX = error message associated with error code in EAX
	libcall err.text, eax

	;write error message
	libcall stderr.write.format, <10,"Error: %s!",10>, eax

	;uninitialize FASMLIB
	libcall fasmlib.shutdown

	;end program with exit code 1
	libcall process.exit, 1