;portable part of code


idata {
  ;word delimiter characters
  delims    db 9,10,13,' :,.',0
}

udata {
  ;buffer for file name
  MAX_FILENAME = 80+1
  filename  rb MAX_FILENAME
}

start:
	;initialize FASMLIB
	call	fasmlib.init
	jc	error

	;write prompt
	libcall stdout.write.format, <"Please enter name of file (max %d chars):",10>, MAX_FILENAME-1
	jc	error

	;read file name
	libcall stdin.read.line, filename, MAX_FILENAME
	jc	error

	;EBX = open file
	libcall file.open, filename, 0
	jc	error
	mov	ebx, eax

	;ECX = number of words
	xor	ecx, ecx

	;loop to skip words
next_word:

	;skip word delimiters
	libcall text.skip.chars, ebx, delims
	jc	error2

	;OF is returned if we were on EOF
	jo	done

	;skip all characters until EOF or next delimiter
	libcall text.skip.until, ebx, delims
	jc	error2

	;OF is returned if we were on EOF
	jo	done

	;another word done
	inc	ecx
	jmp	next_word

done:

	;close file
	libcall stream.close, ebx
	jc	error

	;print result
	libcall stdout.write.format, "File %s contains %d words", filename, ecx
	jc	error

	;uninitialize FASMLIB
	call	fasmlib.uninit
	jc	error

	;end program with exit code 0
	libcall process.exit, 0



	;error, but we must also close file
error2:
	push	eax
	libcall stream.close, ebx
	pop	eax

	;on error, EAX contains error code
error:
	;write error message
	libcall err.text, eax
	libcall stderr.write.format, <10,"Error: %s!",10>, eax

	;uninitialize FASMLIB
	libcall fasmlib.shutdown

	;end program with exit code 1
	libcall process.exit, 1