include '../../src/fasmlib/version.inc'

db ";FASMLIB includes for NASM and YASM",10
db ";can be used for MS-COFF and ELF versions",10,10

db '%define FASMLIB_VERSION_STRING "', FASMLIB_VERSION_STRING, '"', 10
match x y z, FASMLIB_VERSION_MAJOR FASMLIB_VERSION_MINOR FASMLIB_VERSION_REVISION {
  db '%define FASMLIB_VERSION_MAJOR ', `x, 10
  db '%define FASMLIB_VERSION_MINOR ', `y, 10
  db '%define FASMLIB_VERSION_REVISION ', `z, 10, 10
}

db ';------------------------------------------------------------',10
db '; procedures',10,10

DOT fix '.'
macro fasmlib_proc name, strname, [x] {
  db 'extern ', strname, 10
}
macro fasmlib_data name, strname, [x] {
  db 'extern ', strname, 10
}
include '../../bin/public.inc'

db 10, 10, ';------------------------------------------------------------',10
db '; error codes ',10,10

macro errtable [name, text]
{
  x equ 0
  forward
    match _x, x \{
      db '%define ',`name,'   ',9,\`_x, 9, 9, ';', text, 10
      rept 2 _z:_x \\{
	x equ _z
      \\}
    \}
}
include '../../src/err/table.inc'

db 10, 10, ';------------------------------------------------------------',10
db '; structures',10,10
file 'strucs.inc'
