; see 'src/_win32/fileio/create.inc' for description
proc fileio.create name, overwr, mode
	push ebx ecx edx

	;check if mode is 1 or 2
	mov	eax, [mode]
	test	eax, eax
	jz	.error_invalid_mode
	cmp	eax, 2
	ja	.error_invalid_mode

	;check if overwr is <=1
	cmp	[overwr], 1
	ja	.error_invalid_mode

	;ECX = file access bits, depending on [overwr] and [mode]
	mov	ecx, 80h+41h		;O_EXCL | O_CREAT | O_WRONLY
	cmp	[overwr], 1
	jne	@f
	xor	ecx, 80h or 200h	;O_EXCL -> O_TRUNC if bit0 set
@@:	cmp	[mode], 1
	je	@f
	inc	ecx			;O_WRONLY->O_RDWR if bit1 set
@@:

	mov	edx, 110100100b 	;file permissions (644)
					;ecx = file access bits already set
	mov	ebx, [name]		;ebx = file name
	mov	eax, 5			;sys_open
	int	80h
	cmp	eax, -4096
	ja	.error_create

	clc

.r:	pop	edx ecx ebx
	ret
.rc:	stc
	jmp	.r

.error_create:

	;catch already-exists
	push	ERR_FILE_EXISTS
	cmp	eax, -17 ;EEXIST
	je	@f
	mov	[esp],eax
@@:	pop	eax
	je	.rc

	;catch can't open
	push	ERR_CANT_OPEN_FILE
	cmp	eax, -2 ;ENOENT
	je	@f
	cmp	eax, -13 ;EACCES
	je	@f
	cmp	eax, -14 ;EFAULT
	je	@f
	cmp	eax, -21 ;EISDIR
	je	@f
	cmp	eax, -26 ;ETXTBUSY
	je	@f
	cmp	eax, -28 ;ENOSPC
	je	@f
	cmp	eax, -30 ;EROFS
	je	@f
	mov	[esp],eax
@@:	pop	eax
	je	.rc

	mov	eax, ERR_UNKNOWN
	jmp	.rc


.error_invalid_mode:
	mov	eax, ERR_INVALID_MODE
	jmp	.rc
endp