; see "src\_win32\fileio\seek.inc" for documentation
proc fileio.seek handle, distlow, disthigh, mode
local position:QWORD
	push	ebx ecx edx esi edi

	;check if mode is 0, 1, or 2
	cmp	[mode], 2
	jbe	@f
	mov	eax, ERR_INVALID_MODE
	jmp	.rc
@@:

	;check if dist is positive if mode is 0
	cmp	[mode], 0
	jne	@f
	cmp	[disthigh], 0
	jge	@f
	mov	eax, ERR_OUT_OF_RANGE
	jmp	.rc
@@:

	mov	edi, [mode]
	lea	esi, [position]
	mov	edx, [disthigh]
	mov	ecx, [distlow]
	mov	ebx, [handle]
	mov	eax, 140	;sys_llseek
	int	80h
	cmp	eax, -4096
	ja	.error_seek

	mov	eax, -1 	;make sure noone uses return value

.rnc:	clc
.r:	pop	edi esi edx ecx ebx
	ret
.rc:	stc
	jmp	.r

.error_seek:
	;catch out-of-bounds
	cmp	eax, -22; EINVAL
	jne	@f
	mov	eax, ERR_NEGATIVE_SEEK
	jmp	.rc
@@:

	;catch invalid-handle
	cmp	eax, -9; EBADF
	jne	@f
	mov	eax, ERR_INVALID_HANDLE
	jmp	.rc
@@:

	mov	eax, ERR_UNKNOWN
	jmp	.rc
endp