;STDOUT stream object

idata {
  if used stderr | INCLUDE_ALL_DATA eq 1
    stderr._vtab STREAM_VTAB   \
	0,		       \;close
	stderr._write,	       \
	0,		       \;read
	0,		       \;peek
	0,		       \;skip
	0,		       \;seek
	0			;tell

    stderr STREAM\
	stderr._vtab,	       \;virtual table
	0,0,0,		       \;no write buffer
	0,0,0			;no read buffer
  end if
}

;; @name stdout._write
;; @desc
;;    This is a {stream write method} for {stdout} stream on win32 platform.
;; @note This is platform-specific procedure.
proc stderr._write, stream, buffer, size
local written dd ?

	push	ebx ecx edx

	;do nothing if size=0
	cmp	[size], 0
	je	.rnc

	;call sys_write()
	mov	edx, [size]
	mov	ecx, [buffer]
	mov	ebx, 2		;stderr
	mov	eax, 4		;sys_write
	int	80h
	cmp	eax, -4096
	ja	.error_write

	;check if all bytes were written
	cmp	eax, [size]
	je	@f
	mov	eax, ERR_UNKNOWN
	jmp	.rc
	@@:

	;return no unwritten bytes
	mov	eax, 0

.rnc:	clc
.r:	pop	edx ecx ebx
	ret
.rc:	stc
	ret

.error_write:
	mov	eax, ERR_UNKNOWN
	jmp	.rc
endp