idata {
  if used stdin | INCLUDE_ALL_DATA eq 1
    stdin._vtab STREAM_VTAB \
	0,		    \ ;close
	0,		    \ ;write
	stdin._read,	    \ ;read
	stdin._peek,	    \ ;peek
	0,		    \ ;skip
	0,		    \ ;seek
	0		      ;tell

    stdin  STREAM\
		stdin._vtab,	       \;virtual table
		0, 0, 0,	       \;no write buf
		2, 0, 0 		;dynamic read buffer
  end if
}

; stdin._readbuf
; internal procedure that reads at <count> bytes to <buffer>.
proc stdin._readbuf, stream, buffer, count
local readen dd ?
	push	ebx ecx edx edi

	;EBX = size
	mov	ebx, [count]
	or	ebx, ebx
	jz	.done			;do nothing if count=0

	;EDI = buffer
	mov	edi, [buffer]

.read:
	;call ReadFile
	;function returns after reading one line, which can be less than size we want
	;call sys_read()
	;function returns after reading one line, which can be less than size we want
	push	ebx
	mov	edx, [count]
	mov	ecx, edi
	mov	ebx, 0		;stdin
	mov	eax, 3		;sys_read
	int	80h
	pop	ebx
	or	eax,eax
	jz	.error_ReadFile

	;if return value is non-zero, and bytes readen is zero, then we are on EOF
	cmp	eax, 0
	je	.done

	;end check if all bytes were readen
	sub	ebx, eax
	je	.done
	jb	.error_readen_more_than_wanted	   ;error if we have read more than we wanted (???)

	;continue reading next line
	add	edi, eax
	jmp	.read

.done:
	;EAX = number of bytes readen
	mov	eax, [count]
	sub	eax, ebx

.rnc:	clc
.r:	pop	edi edx ecx ebx
	ret
.rc:	stc

.error_ReadFile:
	mov	eax, ERR_UNKNOWN
	jmp	.rc

.error_count_zero:
	mov	eax, ERR_ZERO_SIZE
	jmp	.rc

.error_readen_more_than_wanted:
	mov	eax, ERR_FASMLIB
	jmp	.rc
endp


;================================================================
;; @name stdin._read
;; @desc
;;    This is {stream read method:read method} of {stdin} stream.
proc stdin._read stream, buffer, count
	libcall stream._def_read, [stream], [buffer], [count], stdin._readbuf
	ret
endp

;================================================================
;; @name stdin._peek
;; @desc
;;    This is {stream peek method:peek method} of {stdin} stream.
proc stdin._peek stream, count, readlen
	libcall stream._def_peek, [stream], [count], [readlen], stdin._readbuf
	ret
endp