;; @name fileio.close
;; @desc
;;     Closes file handle.
;; @arg handle
;;    File handle (returned by {fileio.open}, {fileio.create} or {fileio.append}).
;; @ret
;;     CF set on error
;; @err ERR_INVALID_HANDLE
;;     Invalid handle passed
;; @err ERR_UNKOWN
;;     Platform-specific error.
;; @note This is platform-dependent procedure
proc fileio.close handle
	push	ecx edx

	push	[handle]
	call	[CloseHandle]

	or	eax,eax
	jz	.error_CloseHandle
	clc


.r:	pop	edx ecx
	ret

.rc:	stc
	jmp .r

.error_CloseHandle:
	call	[GetLastError]

	cmp	eax, 6 ;ERROR_INVALID_HANDLE
	jne	@f
	mov	eax, ERR_INVALID_HANDLE
	jmp	.rc
@@:
	mov	eax, ERR_UNKNOWN
	jmp	.rc

endp