;FASM STANDARD LIBRARY
;Win32 memory routines for use with FASMLIB heap manager

;you can replace src/win32/mem.inc with this file, to use FASMLIB heap manager
;instead of Heap*** Win32API functions. Useful to test heap manager on win32,
;but with this way VirtualAlloc often cannot enlarge block enough

NEED_HEAP_MANAGER equ 1

proc mem.alloc_heap size
	push	ecx edx

	push	40h		;PAGE_EXECUTE_READWRITE
	push	1000h		;MEM_COMMIT
	push	[size]
	push	0		;any address
	call	[VirtualAlloc]
	or	eax,eax
	jz	.error_VirtualAlloc

.rnc:	clc
.r:	pop	edx ecx
	ret
.rc:	stc
	jmp	.r

.error_VirtualAlloc:
	call	[GetLastError]

	;catch out-of-memory
	push	ERR_OUT_OF_MEM
	cmp	eax, 8			;ERROR_NOT_ENOUGH_MEMORY
	je	@f
	cmp	eax, 14 		;ERROR_OUTOFMEMORY
	je	@f
	mov	[esp],eax
@@:	pop	eax
	je	.rc

	mov	eax, ERR_UNKNOWN
	jmp	.rc
endp




proc mem.free_heap block, size

	push	4000h		;MEM_DECOMMIT
	push	[size]
	push	[block]
	call	[VirtualFree]
	test	eax,eax
	jz	.error

.rnc:	clc
.r:	pop	edx ecx
	ret
.rc:	stc
	jmp	.r

.error:
	call	[GetLastError]

	mov	eax, ERR_UNKNOWN
	jmp	.rc
endp



proc mem.realloc_heap heapptr, newsize, oldsize
	push	ecx edx

	push	40h		;PAGE_EXECUTE_READWRITE
	push	1000h		;MEM_COMMIT
	push	[newsize]
	push	[heapptr]	;any address
	call	[VirtualAlloc]
	or	eax,eax
	jz	.error_GlobalReAlloc

.rnc:	clc
.r:	pop	edx ecx
	ret
.rc:	stc
	jmp	.r

.error_GlobalReAlloc:
	call	[GetLastError]

	;catch out-of-memory
	push	ERR_OUT_OF_MEM
	cmp	eax, 8			;ERROR_NOT_ENOUGH_MEMORY
	je	@f
	cmp	eax, 14 		;ERROR_OUTOFMEMORY
	je	@f
	mov	[esp],eax
@@:	pop	eax
	je	.rc

	mov	eax, ERR_UNKNOWN
	jmp	.rc
endp
