idata {
  if used stdin | INCLUDE_ALL_DATA eq 1
    stdin._vtab STREAM_VTAB \
	0,		    \ ;close
	0,		    \ ;write
	stdin._read,	    \ ;read
	stdin._peek,	    \ ;peek
	0,		    \ ;skip
	0,		    \ ;seek
	0		      ;tell

    stdin  STREAM\
		stdin._vtab,	       \;virtual table
		0, 0, 0,	       \;no write buf
		2, 0, 0 		;dynamic read buffer
  end if
}

; callback for default stream handlers
; reads at <count> bytes to <buffer>, returns OF
proc stdin._readbuf, stream, buffer, count
local readen dd ?
	push	ebx ecx edx edi
	pushf

	;EBX = size
	mov	ebx, [count]
	or	ebx, ebx
	jz	.done			;do nothing if count=0

	;EDI = buffer
	mov	edi, [buffer]

.read:
	push	-10 ;STD_INPUT_HANDLE
	call	[GetStdHandle]
	mov	edx, eax

	;call ReadFile
	;function returns after reading one line, which can be less than size we want
	push	0			;reserved
	lea	eax,[readen]
	push	eax			;pointer to variable to hold number of chars readen
	push	ebx			;number of bytes to read
	push	edi			;pointer to buffer
	push	edx			;stdout handle
	call	[ReadFile]
	or	eax,eax
	jz	.error_ReadFile

	;if return value is non-zero, and bytes readen is zero, then we are on EOF
	cmp	[readen], 0
	je	.done

	;end check if all bytes were readen
	sub	ebx, [readen]
	je	.done
	jb	.error_readen_more_than_wanted	   ;error if we have read more than we wanted (???)

	;continue reading next line
	add	edi, [readen]
	jmp	.read

.done:
	;EAX = number of bytes readen
	mov	eax, [count]
	sub	eax, ebx

	;set OF if we didn't read all bytes (EOF)
	cmp	ebx, 0
	ja	.ro

.rno:	and	word [esp], not (1 shl 11) ;clear OF
.rnc:	and	byte [esp], not 1 ;clear CF
.r:	popf
	pop	edi edx ecx ebx
	ret
.rc:	or	byte [esp], 1 ;set CF
	jmp	.r
.ro:	or	word [esp], 1 shl 11 ;set OF
	jmp	.rnc

.error_ReadFile:
	call	[GetLastError]

	;catch invalid handle
	push	ERR_FASMLIB
	cmp	eax, 6 ;ERROR_INVALID_HANDLE
	je	@f
	mov	[esp],eax
@@:	pop	eax
	je	.rc

	mov	eax, ERR_UNKNOWN
	jmp	.rc

.error_count_zero:
	mov	eax, ERR_ZERO_SIZE
	jmp	.rc

.error_readen_more_than_wanted:
	mov	eax, ERR_FASMLIB
	jmp	.rc
endp


;================================================================
;; @name stdin._read
;; @desc
;;    This is {stream read method:read method} of {stdin} stream.
proc stdin._read stream, buffer, count
	libcall stream._def_read, [stream], [buffer], [count], stdin._readbuf
	ret
endp

;================================================================
;; @name stdin._peek
;; @desc
;;    This is {stream peek method:peek method} of {stdin} stream.
proc stdin._peek stream, count, readlen
	libcall stream._def_peek, [stream], [count], [readlen], stdin._readbuf
	ret
endp