;STDOUT stream object

idata {
  if used stdout | INCLUDE_ALL_DATA eq 1
    stdout._vtab STREAM_VTAB   \
	0,		       \;close
	stdout._write,	       \
	0,		       \;read
	0,		       \;peek
	0,		       \;skip
	0,		       \;seek
	0			;tell

    stdout STREAM\
	stdout._vtab,	       \;virtual table
	0,0,0,		       \;no write buffer
	0,0,0			;no read buffer
  end if
}

;; @name stdout._write
;; @desc
;;    This is a {stream write method} for {stdout} stream on win32 platform.
;; @note This is platform-specific procedure.
proc stdout._write, stream, buffer, size
local written dd ?

	push	ecx edx

	;do nothing if size=0
	cmp	[size], 0
	je	.rnc

	;get STDOUT handle
	push	-11 ;STD_OUTPUT_HANDLE
	call	[GetStdHandle]
	mov	ecx, eax

	;call WriteFile
	push	0			;reserved
	lea	eax,[written]
	push	eax			;number of chars written
	push	[size]
	push	[buffer]
	push	ecx
	call	[WriteFile]
	or	eax,eax
	jz	.error_WriteFile

	;check if all bytes were written
	mov	eax, [written]
	cmp	eax, [size]
	je	@f
	mov	eax, ERR_UNKNOWN
	jmp	.rc
	@@:

	;return no unwritten bytes
	mov	eax, 0

.rnc:	clc
.r:	pop	edx ecx
	ret
.rc:	stc
	ret

.error_WriteFile:
	call	[GetLastError]

	mov	eax, ERR_UNKNOWN
	jmp	.rc
endp