;=============================================================================
; extconv.dec2d_size
; desc: INTERNAL! ignore this :]
;       performs job for dec_b, dec_w, dec_d procedures
;=============================================================================
proc extconv.dec2d_size string, strlen, size, len
	push	esi edx ecx ebx

	;error is strlen=0
	cmp	[strlen], 0
	je	.error_zero_size

	;ESI = string
	mov	esi, [string]

	;error if first char isn't digit
	cmp	byte [esi], '0'
	jb	.error_not_dec
	cmp	byte [esi], '9'
	ja	.error_not_dec

	;EBX = final value, for now 0
	mov	ebx, 0

	;ECX = count of converted chars
	mov	ecx, 0

	;loop
.digit_loop:
	;AL=char
	mov	al, [esi]
	inc	esi

	;end if it isn't hex digit
	cmp	al, '0'
	jb	.done
	cmp	al, '9'
	ja	.done

	;convert to binary digit
	sub	al, '0'
	movzx	eax, al

	;add digit
	push	eax esi
	xor	edx, edx
	mov	esi, 10
	mov	eax, ebx
	mul	esi
	pop	esi
	mov	ebx, eax
	pop	eax
	add	ebx, eax

	;check for overflow
	jc	.overflow
	cmp	edx, 0
	ja	.overflow
	cmp	ebx, [size]
	ja	.overflow

	;continue loop
	inc	ecx
	cmp	ecx, [strlen]
	jb	.digit_loop
.done:

	;fill len
	mov	eax, [len]
	cmp	eax, 0
	je	@f
	mov	[eax], ecx
	@@:

	;return EBX
	mov	eax, ebx

	clc
.r:	pop	ebx ecx edx esi
	ret
.rc:	stc
	jmp	.r


.overflow:
	;set len
	mov	eax, [len]
	cmp	eax, 0
	je	@f
	mov	dword [eax], ecx
	@@:

	;return error
	mov	eax, ERR_OUT_OF_RANGE
	jmp	.rc

.error_zero_size:
	;set len to 0
	mov	eax, [len]
	cmp	eax, 0
	je	@f
	mov	dword [eax], 0
	@@:

	;return error
	mov	eax, ERR_ZERO_SIZE
	jmp	.rc


.error_not_dec:
	;set len to 0
	mov	eax, [len]
	cmp	eax, 0
	je	@f
	mov	dword [eax], 0
	@@:

	;return error
	mov	eax, ERR_NOT_DECIMAL
	jmp	.rc
endp