;=============================================================================
; extconv.dec2id_size
; desc: INTERNAL! ignore this :]
;       performs job for dec_ib, dec_iw, dec_id procedures
;=============================================================================
proc extconv.dec2id_size string, strlen, size, allowplus, len
local sign:DWORD
	push	esi edx ecx ebx

	;check args
	cmp	[strlen], 0
	je	.error_zero_size
	cmp	[allowplus], 1
	ja	.error_mode

	;ESI = string
	mov	esi, [string]

	;ECX = count of converted chars
	mov	ecx, 0

	;get sign
	mov	[sign], 0
	cmp	byte [esi], '-'
	jne	taken @f
	inc	esi
	inc	ecx
	mov	[sign], 1
	jmp	.sign_done
	@@:
	cmp	[allowplus], 0
	je	.sign_done
	cmp	byte [esi], '+'
	jne	.sign_done
	inc	esi
	inc	ecx
.sign_done:

	;error if first char isn't digit
	cmp	byte [esi], '0'
	jb	.error_not_dec
	cmp	byte [esi], '9'
	ja	.error_not_dec

	;EBX = final value, for now 0
	mov	ebx, 0

	;loop
.digit_loop:
	;AL=char
	mov	al, [esi]
	inc	esi

	;end if it isn't hex digit
	cmp	al, '0'
	jb	.done
	cmp	al, '9'
	ja	.done

	;convert to binary digit
	sub	al, '0'
	movzx	eax, al

	;add digit
	push	eax esi
	xor	edx, edx
	mov	esi, 10
	mov	eax, ebx
	mul	esi
	pop	esi
	mov	ebx, eax
	pop	eax
	add	ebx, eax

	;check for overflow
	jc	.overflow
	cmp	edx, 0
	ja	.overflow
	cmp	ebx, [size]
	ja	.overflow

	;continue loop
	inc	ecx
	cmp	ecx, [strlen]
	jb	.digit_loop
.done:

	;fill len
	mov	eax, [len]
	cmp	eax, 0
	je	@f
	mov	[eax], ecx
	@@:

	;set sign and check overflow
	cmp	[sign], 0
	jne	.negative
.positive:
	cmp	ebx, [size]
	jae	.overflow
	jmp	.sign_set
.negative:
	cmp	ebx, [size]
	ja	.overflow
	neg	ebx

.sign_set:
	mov	eax, ebx


	clc
.r:	pop	ebx ecx edx esi
	ret
.rc:	stc
	jmp	.r


.overflow:
	;set len
	mov	eax, [len]
	cmp	eax, 0
	je	@f
	mov	dword [eax], ecx
	@@:

	;return error
	mov	eax, ERR_OUT_OF_RANGE
	jmp	.rc

.error_zero_size:
	;set len to 0
	mov	eax, [len]
	cmp	eax, 0
	je	@f
	mov	dword [eax], 0
	@@:

	;return error
	mov	eax, ERR_ZERO_SIZE
	jmp	.rc

.error_mode:
	;set len to 0
	mov	eax, [len]
	cmp	eax, 0
	je	@f
	mov	dword [eax], 0
	@@:

	;return error
	mov	eax, ERR_INVALID_MODE
	jmp	.rc

.error_not_dec:
	;set len to 0
	mov	eax, [len]
	cmp	eax, 0
	je	@f
	mov	dword [eax], 0
	@@:

	;return error
	mov	eax, ERR_NOT_DECIMAL
	jmp	.rc
endp