;; @name conv.b_hex
;; @desc
;;    Converts unsigned byte (8bit) value to hexadecimal string.
;;    For more options use {extconv.b_hex}.
;; @arg dest
;;    Pointer to destination string buffer.
;; @arg destlen
;;    Size of destination string buffer.
;;    Size 3 is always enough for this procedure.
;; @arg value
;;    Byte value to convert.
;;    Only low order byte of this dword is used, rest is ignored.
;; @ret
;;    CF=1 on error.
;; @err ERR_BUFFER_FULL
;;    Destination buffer is not big enough, must be at least 3 bytes.
;;    Only first destlen bytes of resulting string were written.
;;    String in destination buffer is NOT zero terminated.
;; @err ERR_ZERO_SIZE
;;    destlen=0.
;; @nodeps
proc conv.b_hex dest, destlen, value
	movzx	eax, byte [value]
	libcall extconv.d_hex, [dest], [destlen], eax, 0, 0, 0
	ret
endp