;; @name conv.dec_iq
;; @desc
;;    Converts decimal string to signed qword (64bit) value.
;; @arg string
;;    Pointer to string to convert.
;; @arg buflen
;;    Size of string's buffer.
;;    You can set this to -1 (FFFFFFFFh) if string is quaranteed to be properly zero-terminated.
;; @ret
;;    CF=1 on error, otherwise
;;    EAX = value.
;; @err ERR_NOT_DECIMAL
;;    First character of string is not decimal digit.
;; @err ERR_OUT_OF_RANGE
;;    Value is greater than 9223372036854775807 or lesser than -9223372036854775808.
;; @err ERR_ZERO_SIZE
;;    strlen=0
;; @note This procedure converts digits until it reaches non-digit character,
;;       or until value overflows.
;; @note To get number of converted characters, use {extconv.dec_iq}.
;; @nodeps
proc conv.dec_iq string, buflen
	libcall extconv.dec_iq, [string], [buflen], 1, 0
	ret
endp