;; @name conv.dec_q
;; @desc
;;    Converts decimal string to unsigned qword (64bit) value.
;; @arg string
;;    Pointer to string to convert.
;; @arg buflen
;;    Size of string's buffer.
;;    You can set this to -1 (FFFFFFFFh) if string is quaranteed to be properly zero-terminated.
;; @ret
;;    CF=1 on error, otherwise
;;    EDX:EAX = value.
;; @err ERR_NOT_DECIMAL
;;    First character of string is not decimal digit.
;; @err ERR_OUT_OF_RANGE
;;    Value is > 18446744073709551615.
;; @err ERR_ZERO_SIZE
;;    strlen=0
;; @note This procedure converts digits until it reaches non-digit character,
;;       or until value overflows.
;; @note To get number of converted characters, use {extconv.dec_q}.
;; @nodeps
proc conv.dec_q string, buflen
	libcall extconv.dec_q, [string], [buflen], 0
	ret
endp