;; @name extconv.hex_id
;; @desc
;;    Converts hexadecimal string to signed dword (32bit) value.
;;    This is extended version, for simpler version see {conv.hex_id}.
;; @arg string
;;    Pointer to string to convert.
;; @arg buflen
;;    Size of string's buffer.
;;    You can set this to -1 (FFFFFFFFh) if string is quaranteed to be properly zero-terminated.
;; @arg allowplus
;;    If 1, explicit "+" sign before number is allowed.
;; @arg len
;;    Pointer to dword variable, which will on return hold number of converted characters.
;;    Ignored if zero.
;; @ret
;;    CF=1 on error, otherwise
;;    EAX = value.
;; @err ERR_NOT_HEXADECIMAL
;;    First character of string is not hexadecimal digit.
;; @err ERR_OUT_OF_RANGE
;;    Value is lesser than -80000000 or greater than 7FFFFFFF.
;; @err ERR_ZERO_SIZE
;;    strlen=0
;; @note This procedure converts digits until it reaches non-digit character,
;;       or until value overflows.
;; @nodeps
proc extconv.hex_id string, buflen, allowplus, len
	libcall extconv.hex2id_size, [string], [buflen], 80000000h, [allowplus], [len]
	ret
endp