;; @name extconv.hex_w
;; @desc
;;    Converts hexadecimal string to unsigned word (16bit) value.
;;    This is extended version, for simpler version see {conv.hex_w}.
;; @arg string
;;    Pointer to string to convert.
;; @arg buflen
;;    Size of string's buffer.
;;    You can set this to -1 (FFFFFFFFh) if string is quaranteed to be properly zero-terminated.
;; @arg len
;;    Pointer to dword variable, which will on return hold number of converted characters.
;;    Ignored if zero.
;; @ret
;;    CF=1 on error, otherwise
;;    EAX = value (AX zero extended to dword).
;; @err ERR_NOT_HEXADECIMAL
;;    First character of string is not hexadecimal digit.
;; @err ERR_OUT_OF_RANGE
;;    Value is > FFFF
;; @err ERR_ZERO_SIZE
;;    strlen=0
;; @note This procedure converts digits until it reaches non-digit character,
;;       or until value overflows.
;; @nodeps
proc extconv.hex_w string, buflen, len
	libcall extconv.hex2d_size, [string], [buflen], 0F000h, [len]
	ret
endp