;; @name conv.hex_b
;; @desc
;;    Converts hexadecimal string to unsigned byte (8bit) value.
;; @arg string
;;    Pointer to string to convert.
;; @arg buflen
;;    Size of string's buffer.
;;    You can set this to -1 (FFFFFFFFh) if string is quaranteed to be properly zero-terminated.
;; @ret
;;    CF=1 on error, otherwise
;;    EAX = value (AL zero extended to dword).
;; @err ERR_NOT_HEXADECIMAL
;;    First character of string is not hexadecimal digit.
;; @err ERR_OUT_OF_RANGE
;;    Value is > FF
;; @err ERR_ZERO_SIZE
;;    strlen=0
;; @note This procedure converts digits until it reaches non-digit character,
;;       or until value overflows.
;; @note To get number of converted characters, use {extconv.hex_b}.
;; @nodeps
proc conv.hex_b string, buflen
	libcall extconv.hex2d_size, [string], [buflen], 0F0h, 0
	ret
endp