;; @name conv.iw_hex
;; @desc
;;    Converts signed word (16bit) value to hexadecimal string.
;;    For more options use {extconv.iw_hex}.
;; @arg dest
;;    Pointer to destination string buffer.
;; @arg destlen
;;    Size of destination string buffer.
;;    Size 6 is always enough for this procedure.
;; @arg value
;;    Word value to convert.
;;    Only low order word of this dword is used, rest is ignored.
;; @ret
;;    CF=1 on error.
;; @err ERR_BUFFER_FULL
;;    Destination buffer is not big enough, must be at least 6 bytes.
;;    Only first destlen bytes of resulting string were written.
;;    String in destination buffer is NOT zero terminated.
;; @err ERR_ZERO_SIZE
;;    destlen=0.
;; @nodeps
proc conv.iw_hex dest, destlen, value
	movsx	eax, word [value]
	libcall extconv.id_hex, [dest], [destlen], eax, 0, 0, 0, 0
	ret
endp
