;FASM STANDARD LIBRARY
;Basic procedure definition macros




;FASMLIB doesn't yet have implemented it's own "proc" macros
;so we need to include this one, it is stolen from FASM standard windows macros
include "proc32.inc"


;alias - to assign another name to procedure
macro alias newname, origname
{
  if used newname | INCLUDE_ALL_PROCS eq 1
    label newname at origname
  end if
  match =1, DISPLAY_FASMLIB_INFO \{
    fasmlib_aliases = fasmlib_aliases+1
  \}
}

;leaf procedure... used to make sources more parsable
macro leafproc name
{
  local ..endofproc
  endofproc equ ..endofproc
  match =1, DISPLAY_FASMLIB_INFO \{
    fasmlib_procs = fasmlib_procs+1
  \}
  align 4

  if used name | INCLUDE_ALL_PROCS eq 1
    name:

  match =1, DISPLAY_PROC_INFO \{
    disp '- leaf procedure "'#`name#'" at: 0x', hex name, ', size=', dec endofproc-name, ' (0x', hex endofproc-name, ')'
  \}
}

macro endlp
{
  endofproc:
  restore endofproc
  end if
}

;=======================================================
; __libcall_pushd
; desc: for internal use of libcall macro to push arguments
macro __libcall_pushd value*
{
  ;if value is "something, ..." save it as string
  match first =, more, value
  \{
    \local ..address
    idata \\{
    ..address db value,0
    \\}
    push dword ..address
     __libcall_stack equ __libcall_stack+4
    ifend equ			;used for else-if construction, if "ifend" is defined then all other conditions are false
  \}

  ;if value is "addr something" load it with "lea eax"
  match ifend =addr var,ifend value
  \{
    \local ..opcode,..address
    virtual at 0
      label ..address at var
      mov eax,dword [..address]
      load ..opcode from 0
    end virtual
    if ..opcode = 0A1h
      push dword var
    else
      push eax
      lea eax, [..address]
      xchg eax, [esp]
     end if
     __libcall_stack equ __libcall_stack+4
     ifend equ
  \}
  ;if value is "qword [something]" or "qword ptr something" use 2 pushes
  match ifend =qword [var],ifend value
  \{
    push dword [var+4]
    push dword [var]
     __libcall_stack equ __libcall_stack+8
     ifend equ
  \}
  match ifend =qword =ptr var,ifend value
  \{
     push dword [var+4]
     push dword [var]
      __libcall_stack equ __libcall_stack+8
     ifend equ
  \}
  ;if value is "qword something" use 2 pushes (more tricky, needs to be loaded)
  match ifend =qword num,ifend value
  \{
     \local ..high,..low
     virtual at 0
	dq num
	load ..low dword from 0
	load ..high dword from 4
     end virtual
     push dword ..high
     push dword ..low
     __libcall_stack equ __libcall_stack+8
     ifend equ
  \}
  ;else
  match ifend, ifend
  \{
     \local ..address
     idata \\{
	if value eqtype ''
	   ..address db value,0
	end if
     \\}
     if value eqtype ''
	push dword ..address
     else
	push value
     end if
      __libcall_stack equ __libcall_stack+4
  \}
  restore ifend

  ;EAX check (if eax is used after nested libcall it's value is modified)
  match =1 =eax, __libcall_nested value \{
    __preprocess_error "WARNING: eax used after nested libcall, it's value is modified!!!"
  \}
}

;================================================
; macro which allows nested libcall
macro __libcall_allow_nesting
{
  ;redefine __libcall_pushd for case when argument is <libcall something>
  macro __libcall_pushd value*
  \{
     ;if "value" is <libcall ...>
     match =ifend =libcall procargs,ifend value \\{

	__libcall_allow_nesting 		 ;redefine libcall macro again
	libcall procargs			 ;do the call
	purge __libcall_pushd, libcall		 ;restore macro redefinitons
	push eax				 ;store returned argument
	__libcall_stack equ __libcall_stack+4
	ifend equ				 ;ignore next match

	;EAX check (if eax is used after nested libcall it's value is modified)
	match =__libcall_nested, __libcall_nested \\\{
	   __libcall_nested equ 1
	\\\}

     \\}
     ;else
     match =ifend,ifend \\{
	__libcall_pushd <value>
	ifend equ
     \\}
     restore ifend
   \} ;macro push declaration

   ;we need to redefine libcall for each level of nesting
   macro libcall proc*,[arg]
   \{
      \common
	 local ..noerr
	 thisESP equ __libcall_stack
	 match anything,arg \\{
      \reverse
	   __libcall_pushd <arg>
      \common
	 \\}
	 call proc
	 if thisESP eq 0
	   jc untaken __libcall_ret
	 else
	   jnc taken ..noerr
	   __libcall_stack equ thisESP
	   lea esp, [esp+thisESP]
	   jmp __libcall_ret
	   ..noerr:
	 end if
	 restore thisESP
   \}
}

;allow nested libcalls
__libcall_allow_nesting

;topmost libcall (to allow returning from inner libcall if CF=1)
macro libcall proc*,[arg]
{
   common
      local ..ret
      __libcall_ret equ ..ret
      __libcall_stack equ 0
      match anything,arg \{
   reverse
      __libcall_pushd <arg>
   common
      \}
      call proc
      ..ret:
      restore __libcall_stack
      restore __libcall_nested
      restore __libcall_ret
}