;FASMLIB
;this file contains macros that handle conversion of timedate stamp

;==============================================
;gettimedate
;desc: macro to get current date as constants
;      DAY, MONTH, YEAR
;      DATE = date in (EU) string format for easier definition with "db" or "du"
macro gettimedate {
  local T

  macro months [dayscount]
  \{
    \forward
     if DAY > dayscount
      DAY = DAY-dayscount
      MONTH = MONTH+1
    \forward
     end if
  \}
  T = %T
  SECOND = T mod (24*3600)
  HOUR = SECOND / 3600
  MINUTE = (SECOND - 3600*HOUR) / 60
  SECOND = SECOND - 3600*HOUR - 60*MINUTE
  DAY = T/(24*3600)
  DAY = DAY - (DAY+365)/(3*365+366)
  YEAR = 1970+DAY/365
  DAY = DAY mod 365 + 1
  MONTH = 1
  if YEAR mod 4 = 0
    FEBDAYS=29
  else
    FEBDAYS=28
  end if
  months 31,FEBDAYS,31,30,31,30,31,31,30,31,30,31
  purge months

  TIME equ (HOUR/10)+'0', (HOUR mod 10)+'0',\
	   ':',\
	   (MINUTE/10)+'0', (MINUTE mod 10)+'0',\
	   ':',\
	   (SECOND/10)+'0', (SECOND mod 10)+'0'

  DATE equ (YEAR/1000)+'0', ((YEAR/100) mod 10)+'0', ((YEAR/10) mod 100)+'0', (YEAR mod 10)+'0',\
	   '-', \
	   (MONTH/10) +'0', (MONTH mod 10)+'0',\
	   '-',\
	   (DAY/10)   +'0', (DAY mod 10)  +'0'

}