;;@name fasmlib.uninit
;;@desc
;;    Uninitializes all modules in FASMLIB.
;;    In current version, it calls {mem.uninit} and {stdstream.uninit}.
;;@ret
;;    CF=1 on error
;;@warn
;;    If any called procedure returns error, this procedure immediately returns.
;;    This behavior is not ideal for error handlers. Use {fasmlib.shutdown} in error handlers.
proc fasmlib.uninit
	libcall stdstream.uninit
	jc	.r
	libcall mem.uninit
	jc	.r
.r:	ret
endp