;interface of HEAPBLOCK and heap manager constants
struc HEAPBLOCK {
  .sign dw 'HB' 	 ;signature of block. must be 'HB' (heap block)
  .used db ?		 ;0 = block is unused, 1 = block is used
  .last db ?		 ;0 = block isn't last, 1 = block is last
			 ;only valid for used blocks
  .size dd ?		 ;real size of this block (not including header)
  .prev dd ?		 ;pointer to previous block. 0=this is first block
  .asize dd ?		 ;allocated size of this block (can be smaller than real size)
}
virtual at 0
  HEAPBLOCK HEAPBLOCK
  sizeof.HEAPBLOCK:
  match =1, DISPLAY_STRUC_INFO {
    disphex 'sizeof HEAPBLOCK object: ',sizeof.HEAPBLOCK
  }
end virtual


;heap size alignment (default = 4KB)
;it's value must be power of two!!!
match =HEAP_SIZE_ALIGN, HEAP_SIZE_ALIGN {
  HEAP_SIZE_ALIGN equ 4096
}

;intial heap size (default = 16KB)
;must be multiple of HEAP_SIZE_ALIGN
match =HEAP_INIT_SIZE, HEAP_INIT_SIZE {
  HEAP_INIT_SIZE equ 16384
}

;sizes of block will be multiples of this value (default = 8 bytes)
;any smaller free block will be left out as padding
;it's value must be power of two!!!
match =HEAP_BLOCK_ALIGN, HEAP_BLOCK_ALIGN {
  HEAP_BLOCK_ALIGN equ 8
}

;minimal size of block, when it is split from block whose size shrinked
;must be multiple of HEAP_BLOCK_ALIGN
match =HEAP_MIN_SPLIT_SIZE, HEAP_MIN_SPLIT_SIZE {
  HEAP_MIN_SPLIT_SIZE equ HEAP_BLOCK_ALIGN
}