; interface of STREAM object

;; virtual table for streams
struc STREAM_VTAB		\
      close,			\
      write,			\
      read,			\
      peek,			\
      skip,			\
      seek,			\
      tell
{
align 4
.:
.sign	       dd 'STRM'	 ; marker of stream virtual table
.close	       dd close 	 ; close(stream)
.write	       dd write 	 ; write(stream, buffer, count)
.read	       dd read		 ; read(stream, buffer, count) -> OF, EAX
.peek	       dd peek		 ; peek(stream, count, readlen) -> OF, EAX
.skip	       dd skip		 ; skip(stream, count) -> OF, EAX
.seek	       dd seek		 ; seek(stream, destlow, desthigh, type)
.tell	       dd tell		 ; tell(stream) -> EDX:EAX
}
virtual at 0
  STREAM_VTAB STREAM_VTAB 0,0,0,0,0,0,0
  sizeof.STREAM_VTAB = $
  match =1, DISPLAY_STRUC_INFO {
    disp 'size of STREAM_VTAB object: ', dec sizeof.STREAM_VTAB, ' (0x', hex sizeof.STREAM_VTAB, ')'
  }
end virtual



;; stream structure
struc STREAM \
      vtab, \
      wbuftype, wbuf, wbufsize,\
      rbuftype, rbuf, rbufsize
{
align 4 		       ;needed more than it may seem ;)
.:
.vtab	   dd vtab+0	       ;pointer to vtab. also can act as RTTI :)

.wbuf	   dd wbuf+0	       ;pointer to write buffer
.wbuf.size dd wbufsize+0       ;size of write buffer
.wbuf.pos  dd 0 	       ;index in write buffer, where unwritten data starts
.wbuf.cnt  dd 0 	       ;number of bytes in write buffer, must be 0 if wbuf.type=0

.rbuf	   dd rbuf+0	       ;pointer to read buffer
.rbuf.size dd rbufsize+0       ;size of read buffer
.rbuf.pos  dd 0 	       ;index in read buffer, where unread data starts
.rbuf.cnt  dd 0 	       ;number of bytes in read buffer, must be 0 if rbuf.type=0

.rbuf.type db rbuftype+0       ;0=no buffer, 1=static, 2=dynamic (can be reallocated)
.rbuf.eof  db 0 	       ;1 if EOF is behind data in buffer
.wbuf.type db wbuftype+0       ;0=no buffer, 1=static, 2=dynamic (can be reallocated)

.allocated db 0 	       ;0 if stream is static, 1 if stream is allocated
align 4
}

virtual at 0
  STREAM STREAM
  sizeof.STREAM = $
  match =1, DISPLAY_STRUC_INFO {
    disp 'size of STREAM object: ', dec sizeof.STREAM, ' (0x', hex sizeof.STREAM, ')'
  }
end virtual
