;; @name stream.read.byte
;; @desc
;;    Reads one byte from stream.
;;    Returns OF if EOF is occured before reading byte.
;; @arg stream
;;    Handle of stream to read from.
;; @ret
;;    CF = 1 on error, otherwise
;;    OF = 1 if we are on EOF, otherwise
;;    AL = byte from stream
proc stream.read.byte stream
local buf rb 1
	lea	eax, [buf]
	libcall stream.read, [stream], eax, 1
	jc	.r
	jo	.r
	mov	al, byte [buf]
	clc
.r:	ret
endp