;TODO: alias stream.writew

;; @name stream.write.word
;; @desc
;;    Writes one word (2 bytes) to stream.
;; @arg stream
;;    Handle of stream to which we write.
;; @arg value
;;    Word value to write.
;;    Only low order word of this dword is used, rest is ignored.
;; @ret
;;    CF set on error
;; @err ERR_INVALID_HANDLE
;;    Not a valid stream handle.
;; @err ERR_STREAM_NOT_WRITABLE
;;    Stream is not writeable.
;; @note This is just a helper procedure to call {stream write method}.
proc stream.write.word stream, value
	lea	eax, [value]
	libcall stream.write, [stream], eax, 2
	ret
endp