;; @name text.skip.chars
;; @desc
;;     Skips all characters which are in given character list from stream.
;;     This is simpler version of procedure, for extended version see {text.extskip.chars}.
;; @arg stream
;;     Stream to skip characters from.
;; @arg charlist
;;     Null-terminated string containing list of characters to read.
;; @ret
;;    CF=1 on error, otherwise
;;    OF=1 if we are on EOF, otherwise
;;    EAX = number of characters skipped
;; @note
;;    This function never skips character 0 from stream.
proc text.skip.chars stream, charlist
	libcall text.extskip.chars, [stream], [charlist], -1
	ret
endp
