;; @name text.skip.until
;; @desc
;;     Skips all characters from stream, until it reaches character from given character list.
;;     This is simpler version of procedure, for extended version see {text.extskip.until}.
;; @arg stream
;;     Stream to skip characters from.
;; @arg charlist
;;     Null-terminated string containing list of characters which not to skip.
;; @ret
;;    CF=1 on error, otherwise
;;    OF=1 if we are on EOF, otherwise
;;    EAX = number of characters skipped
;; @note
;;    This function never skips character 0 from stream.
proc text.skip.until stream, charlist
	libcall text.extskip.until, [stream], [charlist], -1
	ret
endp
