;; @name text.write
;; @desc
;;    Writes null-terminated ASCII string to {stream}.
;;    This function should be only used with constant string argument.
;;    Use {text.fetch.str} for non-constant strings.
;; @arg stream
;;    Handle of stream to write to.
;;    For standard streams, you can use {stdout.write} or {stderr.write}.
;; @arg string
;;    Pointer to string.
;; @ret CF set on error
;; @warn Only use this if string is guaranteed to be null terminated.
;;       Otherwise, use {text.write.str}.
proc text.write stream, string
	libcall str.len, [string], -1
	jc	.r
	libcall stream.write, [stream], [string], eax
.r:	ret
endp
