;; @name text.write.b_hex
;; @desc
;;    Writes unsigned byte (8 bit) to stream as ASCII hexadecimal string.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Low order byte of this dword is value to write.
;; @ret
;;    CF set on error
;; @note This is simpler version of procedure, for extended version see {text.extwrite.b_hex}.
;; @note For signed version, see {text.write.ib_hex}.
proc text.write.b_hex stream, value
local	len	dd ?
local	buf	rb 3

	libcall extconv.b_hex, addr buf, 3, [value], 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp