;; @name text.write.d_hex
;; @desc
;;    Writes unsigned dword (32 bit) to stream as ASCII hexadecimal string.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Dword value to write.
;; @ret
;;    CF set on error
;; @note This is simpler version of procedure, for extended version see {text.extwrite.d_hex}.
;; @note For signed version, see {text.write.id_hex}.
proc text.write.d_hex stream, value
local	len	dd ?
local	buf	rb 9

	libcall extconv.d_hex, addr buf, 9, [value], 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
