;; @name text.write.ib_hex
;; @desc
;;    Writes signed byte (8 bit) to stream as ASCII hexadecimal string.
;;    This is simpler version of procedure, for extended version see {text.extwrite.b_hex}.
;;    For unsigned version, see {text.write.b_hex        }.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Low order byte of this dword is value to write.
;; @ret
;;    CF set on error
proc text.write.ib_hex stream, value
local	len	dd ?
local	buf	rb 4

	libcall extconv.ib_hex, addr buf, 4, [value], 0, 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
