;; @name text.write.id_hex
;; @desc
;;    Writes signed dword (32 bit) to stream as ASCII hexadecimal string.
;;    This is simpler version of procedure, for extended version see {text.extwrite.id_hex}.
;;    For unsigned version, see {text.write.d_hex}.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Dword value to write.
;; @ret
;;    CF set on error
proc text.write.id_hex stream, value
local	len	dd ?
local	buf	rb 10

	libcall extconv.id_hex, addr buf, 10, [value], 0, 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
