;; @name text.write.iw_dec
;; @desc
;;    Writes signed word (16 bit) to stream as ASCII decimal string.
;;    This is simpler version of procedure, for extended version see {text.extwrite.iw_dec}.
;;    For unsigned version, see {text.write.w_dec}.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Low order word of this dword is value to write.
;; @ret
;;    CF set on error
proc text.write.iw_dec stream, value
local	len	dd ?
local	buf	rb 7

	libcall extconv.iw_dec, addr buf, 7, [value], 0, 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
