;; @name text.write.iw_hex
;; @desc
;;    Writes signed word (16 bit) to stream as ASCII hexadecimal string.
;;    This is simpler version of procedure, for extended version see {text.extwrite.iw_hex}.
;;    For unsigned version, see {text.write.w_hex}.
;; @arg stream
;;    Handle of stream to write to.
;; @arg value
;;    Low order word of this dword is value to write.
;; @ret
;;    CF set on error
proc text.write.iw_hex stream, value
local	len	dd ?
local	buf	rb 6

	libcall extconv.iw_hex, addr buf, 6, [value], 0, 0, 0, addr len
	jc	.rc

	libcall stream.write, [stream], addr buf, [len]
	jc	.rc

.r:	ret
.rc:	stc
	jmp	.r
endp
