;; @name text.write.str
;; @desc
;;    Writes string to {stream}.
;;    If string is guaranteed to be null terminated, you can use {text.write} instead.
;; @arg stream
;;    Handle of stream to write to. For standard streams, you can use
;;    {stdout.write.str} or {stderr.write.str}.
;; @arg string
;;    Pointer to string.
;; @arg buflen
;;    Length of string buffer.
;; @ret CF set on error
proc text.write.str stream, string, buflen
	libcall str.len, [string], [buflen]
	jc	.r
	libcall stream.write, [stream], [string], eax
.r:	ret
endp
