; this tests if argument counts in 'bin/public.inc' and 'bin/internal.inc'
; corresponds to argument counts in sources
; win32 version

format PE

section '.flat' code data executable readable writeable

;load argument counts
macro fasmlib_proc name, strname, count
{
  name#__argc equ count
}
macro fasmlib_data [x] {}
DOT fix '.'
include '%FASMLIB%/bin/internal.inc'
include '%FASMLIB%/bin/public.inc'

;check all procedures
SYSTEM equ win32
INCLUDE_ALL_PROCS equ 1
INCLUDE_ALL_PROCS equ 1
include '%FASMLIB%/src/fasmlib.inc'

macro proc name,[arg] {
common
  local argc, real_name, else
  else equ 1
  match _name _arg,name \{ ;parse first argument
    real_name equ _name
    argc = 4
    else equ 0
  \}
  match =1, else \{
    argc = 0
    real_name equ name
    arg1 equ 0
  \}
  if ~ arg eq
forward
  argc = argc + 4
common
  end if
  match _name, real_name \{
    if defined _name\#__argc
      if argc <> _name\#__argc
	display 'argument count error in "',\`_name,'"'       __error
      end if
    end if
  \}
  match ,arg \{
    proc name
  \}
  match x,arg \{
    proc name, arg
  \}
}
macro alias a,b {
  label a at b
}


include '%FASMLIB%/src/err.inc'
include '%FASMLIB%/src/mem.inc'
include '%FASMLIB%/src/fileio.inc'
include '%FASMLIB%/src/conv.inc'
include '%FASMLIB%/src/str.inc'
include '%FASMLIB%/src/process.inc'
include '%FASMLIB%/src/stream.inc'
include '%FASMLIB%/src/text.inc'
include '%FASMLIB%/src/stdstream.inc'
include '%FASMLIB%/src/fstream.inc'
include '%FASMLIB%/src/mstream.inc'

;now let's check again if we tested all procedures
macro fasmlib_proc name, strname, count
{
  if ~defined name
    display 'procedure ',`name,' not tested', 0 	__error
  end if
}
include '%FASMLIB%/bin/internal.inc'
include '%FASMLIB%/bin/public.inc'

IncludeIData
IncludeUData

;imports
section '.import' data import readable
	;standard FASM macros for importing
	include "C:/dev/compiler/fasm/include/macro/import32.inc"

	;imports that FASMLIB needs
	library kernel32, "kernel32.dll"
	include "C:/dev/compiler/fasm/include/API/kernel32.inc"
